package com.gmei.sink;

import com.gmei.bean.bl.BlPreciseExposureBean;
import com.gmei.bean.ml.MlPreciseExposureBean;
import com.gmei.cache.MlPreciseExposureDao;
import com.gmei.function.BlPreciseExposureMapFunction;
import com.gmei.function.MlpreciseExposureFlatMapFunction;
import com.gmei.jdbc.MysqlJdbcBl;
import org.junit.Test;

import java.util.ArrayList;

public class MlPreciseExposureMysqlSinkTest {

    @Test
    public void mlMysqlSinkTest() {
        String sinkJdbcUrl = "";
        String sinkTableName = "";
        String json = "{\"create_at\":\"1575135041\",\"gm_nginx_timestamp\":1575135040.498,\"user_id\":\"\",\"version\":\"147\",\"params\":{\"down_loading_times\":0,\"up_slide_times\":6,\"is_exposure\":\"1\",\"exposure_cards\":[{\"absolute_position\":0,\"relative_position\":0,\"card_type\":\"card\",\"wiki_word\":[\"项目档案:1\",\"手术锦囊:2\",\"相近项目:3\"],\"card_content_type\":\"qa\",\"card_id\":\"7\"},{\"cpc_referer\":\"1\",\"relative_position\":0,\"transaction_type\":\"\",\"card_type\":\"card\",\"absolute_position\":0,\"card_content_type\":\"answer\",\"card_id\":\"684889\"},{\"cpc_referer\":\"1\",\"relative_position\":1,\"transaction_type\":\"\",\"card_type\":\"card\",\"absolute_position\":1,\"card_content_type\":\"answer\",\"card_id\":\"692624\"},{\"cpc_referer\":\"1\",\"relative_position\":2,\"is_cpc\":0,\"transaction_type\":\"-1\",\"card_type\":\"card\",\"absolute_position\":2,\"card_content_type\":\"user_post\",\"card_id\":66263},{\"cpc_referer\":\"1\",\"relative_position\":3,\"is_cpc\":0,\"transaction_type\":\"-1\",\"card_type\":\"card\",\"absolute_position\":3,\"card_content_type\":\"user_post\",\"card_id\":70670},{\"cpc_referer\":\"1\",\"relative_position\":4,\"is_cpc\":0,\"transaction_type\":\"-1\",\"card_type\":\"card\",\"absolute_position\":4,\"card_content_type\":\"diary\",\"card_id\":15329391},{\"cpc_referer\":\"1\",\"relative_position\":4,\"transaction_type\":\"\",\"card_type\":\"card\",\"absolute_position\":5,\"card_content_type\":\"article\",\"card_id\":\"19507071\"},{\"cpc_referer\":\"1\",\"relative_position\":5,\"transaction_type\":\"\",\"card_type\":\"card\",\"absolute_position\":6,\"card_content_type\":\"answer\",\"card_id\":\"518138\"},{\"cpc_referer\":\"1\",\"relative_position\":4,\"transaction_type\":\"\",\"card_type\":\"card\",\"absolute_position\":7,\"card_content_type\":\"answer\",\"card_id\":\"684319\"},{\"cpc_referer\":\"1\",\"relative_position\":5,\"is_cpc\":0,\"transaction_type\":\"-1\",\"card_type\":\"card\",\"absolute_position\":8,\"card_content_type\":\"user_post\",\"card_id\":69002}],\"tab_name\":\"综合\",\"down_slide_times\":0,\"query\":\"纹眉\",\"filter\":\"\",\"referrer_id\":\"\",\"referrer\":\"search_home\",\"up_loading_times\":0,\"business_id\":\"\",\"page_name\":\"search_result_more\"},\"app_session_id\":\"424bcbcf-3b6e-4331-89b3-9fcd0c7bfbaf\",\"app\":{\"version\":\"7.18.4\",\"grey_type\":\"{\\\"video_steep\\\":1,\\\"post_detail\\\":\\\"0\\\",\\\"face_detect_result\\\":\\\"B\\\",\\\"home\\\":\\\"0\\\",\\\"face_scan\\\":0,\\\"report_result\\\":0}\",\"current_city_id\":\"chongqing\",\"user_type\":{\"config_type\":\"1\"},\"name\":\"gengmei_user\",\"serial_id\":35,\"channel\":\"huawei\"},\"gm_nginx_key\":1,\"device\":{\"android_device_id\":\"androidid_b49fb6a87b10bad0\",\"sys_version\":\"9\",\"lng\":\"106.618722\",\"is_WiFi\":\"0\",\"lat\":\"29.720561\",\"device_id\":\"861198041466947\",\"manufacturer\":\"HUAWEI\",\"net_type\":\"4G\",\"device_type\":\"android\",\"ip\":\"192.168.3.3\",\"model\":\"LYA-AL00\"},\"type\":\"page_precise_exposure\"}";

//        String json = "{\"create_at\":\"1576347089\",\"gm_nginx_timestamp\":1576347089.299,\"user_id\":\"31961883\",\"version\":\"110\",\"params\":{\"down_loading_times\":0,\"up_slide_times\":5,\"exposure_cards\":{},\"tab_name\":\"service\",\"down_slide_times\":1,\"page_name\":\"category\",\"up_loading_times\":1,\"is_exposure\":\"1\",\"referrer\":\"home\",\"business_id\":\"9\",\"filter\":\"智能排序\",\"referrer_id\":\"\"},\"app_session_id\":\"0092AC31-EF72-44FF-AE1E-8BB6F8448A08\",\"app\":{\"version\":\"7.19.1\",\"grey_type\":\"{\\n  \\\"report_result\\\" : 0,\\n  \\\"face_detect_result\\\" : \\\"B\\\",\\n  \\\"home\\\" : \\\"0\\\",\\n  \\\"post_detail\\\" : \\\"0\\\",\\n  \\\"video_steep\\\" : 0,\\n  \\\"face_scan\\\" : 0\\n}\",\"current_city_id\":\"liuan\",\"name\":\"gengmei_user\",\"user_type\":{\"config_type\":1},\"serial_id\":28,\"channel\":\"App Store\"},\"gm_nginx_key\":1,\"device\":{\"idfv\":\"51E1C5FD-B710-4820-91A6-E54C77AA4C60\",\"sys_version\":\"12.4.1\",\"lng\":116.48697900811,\"is_WiFi\":\"1\",\"manufacturer\":\"Apple\",\"device_id\":\"CD1187A7-091C-4497-96A3-A716BE510905\",\"device_type\":\"ios\",\"ip\":\"192.168.0.101\",\"idfa\":\"CD1187A7-091C-4497-96A3-A716BE510905\",\"lat\":31.757989657248,\"model\":\"iPhone10,1\"},\"type\":\"page_precise_exposure\"}";
//        String json = "{\"app\":{\"user_type\":{\"config_type\":1},\"serial_id\":5,\"name\":\"gengmei_user\",\"channel\":\"App Store\",\"version\":\"7.7.40\",\"current_city_id\":\"beijin\n" +
//                "g\"},\"app_session_id\":\"805E7CE4-0FB1-44E1-B32F-837B62D11D91\",\"gm_nginx_timestamp\":1576347092.686,\"user_id\":\"29105318\",\"gm_nginx_key\":1,\"creat\n" +
//                "e_at\":\"1576347092\",\"params\":{\"exposure_cards\":{ },\"referrer\":\"\",\"referrer_id\":\"\",\"up_slide_times\":0,\"down_loading_times\":0,\"page_name\":\"home\"\n" +
//                ",\"tab_name\":\"精选\",\"business_id\":\"\",\"up_loading_times\":0,\"down_slide_times\":0,\"is_exposure\":1},\"type\":\"home_choiceness_card_exposure\",\"versi\n" +
//                "on\":\"110\",\"device\":{\"lng\":116.25638817524,\"device_id\":\"00DB1D03-3116-4084-AD86-0596EDFA2E3D\",\"is_WiFi\":\"1\",\"ip\":\"10.10.62.107\",\"idfa\":\"00DB1\n" +
//                "D03-3116-4084-AD86-0596EDFA2E3D\",\"idfv\":\"1E6E56F7-3E3C-4F62-83EB-E9DBE7BC1AD1\",\"device_type\":\"ios\",\"lat\":40.073574956895,\"manufacturer\":\"Apple\"}}";
        BlPreciseExposureMapFunction blPreciseExposureMapFunction = new BlPreciseExposureMapFunction();
        MlpreciseExposureFlatMapFunction mlpreciseExposureFlatMapFunction = new MlpreciseExposureFlatMapFunction();
        BlPreciseExposureBean blPreciseExposureBean = null;
        MysqlJdbcBl mysqlJdbcBl = MysqlJdbcBl.getInstance(sinkJdbcUrl);
        MlPreciseExposureDao mlPreciseExposureDao = new MlPreciseExposureDao(sinkJdbcUrl, sinkTableName);
        try {

            blPreciseExposureBean = blPreciseExposureMapFunction.map(json);
//            conn = mysqlJdbcBl.getConnection();
//            conn.setAutoCommit(false);
            ArrayList<MlPreciseExposureBean> mlPreciseExposureBeanArrayList = mlpreciseExposureFlatMapFunction.flatmapBlPreciseExposure(blPreciseExposureBean);
            for (MlPreciseExposureBean mlPreciseExposureBean : mlPreciseExposureBeanArrayList) {
                mlPreciseExposureDao.insertMlPreciseExposure(mlPreciseExposureBean);
            }
//            conn.commit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
